<script setup lang="ts">
import { ref, onMounted, reactive,watch } from "vue";
import type { QTableProps } from "quasar";
import { useCounterMixin } from "@/stores/mixin";
import { useQuasar } from "quasar";
import { useRouter } from "vue-router";

import type { DataOption } from "@/modules/14_KPI/interface/index/Main";
import type { FormQueryCapacity } from "@/modules/14_KPI/interface/request/Main";
import type { ResDataCapacity } from "@/modules/14_KPI/interface/response/Main";

import { useKPIDataStore } from "@/modules/14_KPI/store/KPIStore";

import http from "@/plugins/http";
import config from "@/app.config";

import type {
  NewPagination,
} from "@/modules/14_KPI/interface/index/Main";

const store = useKPIDataStore();
const router = useRouter();
const $q = useQuasar();
const mixin = useCounterMixin();
const { dialogRemove, messageError, showLoader, hideLoader, success } = mixin;

const competencyTypeOp = ref<DataOption[]>([
  {
    id: "HEAD",
    name: "สมรรถนะหลัก",
  },
  {
    id: "GROUP",
    name: "สมรรถนะประจำกลุ่มงาน",
  },
  {
    id: "EXECUTIVE",
    name: "สมรรถนะประจำผู้บริหารกรุงเทพมหานคร",
  },
  {
    id: "DIRECTOR",
    name: "สมรรถนะเฉพาะสำหรับตำแหน่ง ผอ.เขต ผช.ผอ.เขต และหัวหน้าฝ่ายในสังกัด สนง.เขต",
  },
  {
    id: "INSPECTOR",
    name: "สมรรถนะเฉพาะสำหรับตำแหน่งผู้ตรวจราชการ กทม. และผู้ตรวจราชการ",
  },
]);
const columns = ref<QTableProps["columns"]>([
  {
    name: "name",
    align: "left",
    label: "ชื่อสมรรถนะ",
    sortable: true,
    field: "name",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const visibleColumns = ref<string[]>(["name"]);

const rows = ref<ResDataCapacity[]>([]);
const formQuery = reactive<FormQueryCapacity>({
  page: 1,
  pageSize: 10,
  keyword: "",
});
const totalList = ref<number>(1); //จำนวนข้อมูลรายการ

/** ดึงข้อมูล */
async function fetchList() {
  showLoader();
  await http
    .get(
      config.API.kpiCapacity +
        `?page=${formQuery.page}&pageSize=${formQuery.pageSize}&keyword=${formQuery.keyword}&type=${store.competencyType}`
    )
    .then(async (res) => {
      const data: ResDataCapacity[] = res.data.result.data;
      totalList.value = Math.ceil(res.data.result.total / formQuery.pageSize);
      rows.value = data;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

async function onViewDetail(id: string) {
  router.push(`/KPI-competency/${id}`);
}

function deleteData(id: string) {
  dialogRemove($q, () => {
    http
      .delete(config.API.kpiCapacity + `/${id}`)
      .then(() => {
        fetchList();
        success($q, "ลบข้อมูลสำเร็จ");
      })
      .catch((err) => {
        messageError($q, err);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/** เปลี่ยนเป็นหน้าเพิ่มข้อมูล */
function onAdd() {
  router.push(`/KPI-competency/add`);
}

function fetchNewList() {
  formQuery.page = 1;
  fetchList();
}

/**
 * function updatePagination
 * @param newPagination ข้อมูล Pagination ใหม่
 */
 function updatePagination(newPagination: NewPagination) {
  formQuery.page = 1;
  formQuery.pageSize = newPagination.rowsPerPage;
}

watch(
  () => formQuery.pageSize,
  () => {
    fetchNewList();
  }
);

onMounted(() => {
  fetchList();
});
</script>

<template>
  <q-toolbar style="padding: 0">
    <q-select
      v-model="store.competencyType"
      outlined
      label="ประเภทสมรรถนะ"
      dense
      option-label="name"
      option-value="id"
      :options="competencyTypeOp"
      style="min-width: 200px"
      emit-value
      map-options
      @update:model-value="fetchNewList"
    />
    <q-btn flat round color="primary" icon="add" @click="onAdd()">
      <q-tooltip> เพิ่มข้อมูล </q-tooltip>
    </q-btn>
    <q-space />
    <div class="row q-gutter-sm">
      <q-input
        outlined
        dense
        v-model="formQuery.keyword"
        label="ค้นหา"
        @keyup.enter="fetchNewList()"
      >
        <template v-slot:append>
          <q-icon v-if="formQuery.keyword == ''" name="search" />
          <q-icon
            v-if="formQuery.keyword !== ''"
            name="clear"
            class="cursor-pointer"
            @click="(formQuery.keyword = ''), fetchNewList()"
          />
        </template>
      </q-input>
      <q-select
        v-model="visibleColumns"
        multiple
        outlined
        dense
        options-dense
        :display-value="$q.lang.table.columns"
        emit-value
        map-options
        :options="columns"
        option-value="name"
        options-cover
        style="min-width: 150px"
      />
    </div>
  </q-toolbar>

  <d-table
    ref="table"
    :columns="columns"
    :rows="rows"
    row-key="id"
    flat
    bordered
    :paging="true"
    dense
    :rows-per-page-options="[10, 25, 50, 100]"
    class="custom-header-table"
    :visible-columns="visibleColumns"
    @update:pagination="updatePagination"
  >
    <template v-slot:header="props">
      <q-tr :props="props">
        <q-th v-for="col in props.cols" :key="col.name" :props="props">
          <span class="text-weight-medium">{{ col.label }}</span>
        </q-th>
        <q-th auto-width />
      </q-tr>
    </template>
    <template v-slot:body="props">
      <q-tr :props="props" class="cursor-pointer">
        <q-td v-for="col in props.cols" :key="col.id">
          {{ col.value }}
        </q-td>
        <q-td auto-width>
          <q-btn
            color="edit"
            flat
            dense
            round
            size="12px"
            icon="edit"
            clickable
            @click.stop="onViewDetail(props.row.id)"
            v-close-popup
          >
            <q-tooltip>แก้ไข</q-tooltip>
          </q-btn>
          <q-btn
            color="red"
            flat
            dense
            round
            size="12px"
            icon="mdi-delete"
            clickable
            @click.stop="deleteData(props.row.id)"
            v-close-popup
          >
            <q-tooltip>ลบข้อมูล</q-tooltip>
          </q-btn>
        </q-td>
      </q-tr>
    </template>
    <template v-slot:pagination="scope">
      <q-pagination
        v-model="formQuery.page"
        active-color="primary"
        color="dark"
        :max="Number(totalList)"
        size="sm"
        boundary-links
        direction-links
        :max-pages="5"
        @update:model-value="fetchList"
      ></q-pagination>
    </template>
  </d-table>
</template>
